clear all
close all

filename='tut2_footing';%filename
FEnode=[];  FEelt=[]; %reseting default variables
%---------------------------------------------------------Mesh construction
FEel0=[]; 
FEnode=[1 0 0 0 0.  0 .0
        2 0 0 0 0. 10 .0];
NodeID=femesh('findnode z==0.0');
[Y,I]=sort(FEnode(NodeID,6),'ascend');  NodeID=NodeID(I);
femesh('ObjectBeamLine',NodeID)
femesh('extrude 1 0 0 -4')
femesh('divide 8 20')
femesh('addsel')
%---------------------------------------------------Numeration optimization 
[FEnode,FEelt]=feutil('optimnodenum',FEnode,FEelt);
model.Node = FEnode;
model.Elt  = FEelt;
model.Elt  = feutil('orient',model);
model.DOF  = feutil('getdof',model);
model=feutil('renumber',model) 
FEnode=model.Node;
FEelt=model.Elt;
%--------------------------------------------------------Writing file .geom
filename2=[filename,'.geom'];
fid_geom=fopen(filename2,'w');
numnp=length(FEnode(:,1));% total nodes
%Title writing
fprintf(fid_geom,'********* TUTORIAL 2 - RIGID FOOTING **********\n');
%---------------------------------------------------Truncate to 6th decimal
for inod = 1:numnp
    FEnode(inod,5:7)= round(FEnode(inod,5:7)*1e6)*1e-6;
end
%-----------------------------------------------------------Node selections
Node_foot=femesh('findnode z==0. & y<=1.0'); %footing nodes
%-------------------------------------------------------------Nodes writing     
for inod = 1:numnp   
    inode=find(FEnode(:,1)==inod);
    ymin=min(FEnode(:,6)); ymax=max(FEnode(:,6)); 
    zmin=min(FEnode(:,7)); zmax=max(FEnode(:,7)); %mesh limits
    % id = [x y z rx ry rz p 0 neq]
    % standard node definition
    id=[1 0 0 1 1 1 1 0 0];%2D plane-strain mechanic
    %---------------------------------------------------Boundary conditions
    %Footing nodes
    if ismember(inode,Node_foot)==1; id(3)=-1; end%imposed vertical DOF 
    %Lateral limits
    if (abs(FEnode(inode,6)-ymin)<1e-5 || abs(FEnode(inode,6)-ymax)<1e-5) ;
            id(2)=1; end; %fix u_y
    %Bottom limit
    if abs(FEnode(inode,7)-zmin)<1e-5 ;
            id(3)=1; end; %fix u_z
    %Write node
    fprintf(fid_geom,'%5i%2i%2i%2i%2i%2i%2i%2i      %10.4f%10.4f%10.4f%5i%6i\n',...
    inod,id(1:7),FEnode(inode,5),FEnode(inode,6),FEnode(inode,7),id(8),id(9));   
end

%----------------------------------------------------------Elements writing
%NPAR(1)=2: Solid 2D
ITELT=1; IEL=4; IPS=1; EPAI=1.0; MTYP=1; KG=0;%standard parameters
N_group=[160];%number of elements by group
Group_num=[1];%SDT group number
%Quadb elements
for n_group=1:length(N_group)
    group=Group_num(n_group);
    [ind,ELT] = femesh(['findelt Group ',int2str(group)]);
    for M=1:N_group(n_group)
        fprintf(fid_geom,'%5i%1i%2i%2i%20f%5i%5i%5i%5i%5i%5i\n',...
            M,ITELT,IEL,IPS,EPAI,MTYP,KG,ELT(M+1,2),ELT(M+1,1),ELT(M+1,4),ELT(M+1,3));
    end
end
fprintf(fid_geom,'12345678901234567890123456789012345678901234567890123456789012345678901234567890\n');
%close *.geom file
fclose('all')


